<dom-module id="raphael-rect-safe">
  <template>
    <style>
    </style>
    <h2>Resize and drag with constraints</h2>
    <div id="rect-safe"></div>
  </template>

  <script>
    Polymer({

      is: 'raphael-rect-safe',
      ready: function () {

        var paper = Raphael("rect-safe", "100%", 50);

        var rectangle = paper.rect(
          370, 0, 260, 50, 10
        ).attr (
          {
            fill: "#f00",
            stroke: "#fff",
            opacity: "0.2"
          }
        ).drag (
          function (dx) {
            if (this.command === "scaleright") {
              var newwidth = this.owidth + dx;
              if (newwidth > 50) {
                this.attr({width: this.owidth + dx});
              }
            } else if (this.command === "scaleleft"){
              var newwidth = this.owidth - dx;
              if (newwidth > 50) {
                this.attr({width: this.owidth - dx, x: this.ox + dx});
              }
            } else { // drag
              this.attr({x: this.ox + dx});
            }
          },
          function (x) {
            if ( x - this.attr("x") < this.attr("width")/4 ) {
              this.command = "scaleleft";
            } else if ( x - this.attr("x") > 3*this.attr("width")/4 ) {
              this.command = "scaleright";
            } else {
              this.command = "drag"
            }
            this.owidth = this.attr("width");
            this.ox = this.attr("x");
          }
        );
      }
    });
  </script>
</dom-module>
